// *************************************************************************
//    Term.C
// *************************************************************************

#include "Term.h"
#include "Globals.h"
#include "Debug.h"

// *************************************************************************
Cor_Term Cor_Term::dereference()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Cor_Term t = *this;
    while ((t.expr.is_empty()==0)
         && (t.expr.is_var()) && (t.bindenv != NULL)
         && (t.dereference_var().expr.is_empty()==0))
    {
        t = (t.dereference_var());
    }
    return t;
}

// *************************************************************************
//  Stream printing
ostream& operator<< (ostream& out, const Cor_Term& term)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (term.expr.is_empty())
        out << '_';
    else
        term.expr.print(term.bindenv, &out);

    return(out);
}

// *************************************************************************
Cor_Term Cor_QTerm::dereference()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    Cor_Term t(expr,bindenv);

    while ((t.expr.is_empty()==0)
         && (t.expr.is_var()) && (t.bindenv != NULL)
         && (t.dereference_var().expr.is_empty()==0))
    {
        t = (t.dereference_var());
    }

    return(t);
}

// *************************************************************************
//  Stream printing
ostream& operator<< (ostream& out, const Cor_QTerm& term)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (!term.expr || term.expr->is_empty())
        out << '_';
    else
        term.expr->print(term.bindenv, &out);

    return(out);
}

// *************************************************************************
