
//**************************************************************************
//    SockConnectArray.h
//
//    The SockConnectArray Class - A class derived from ConnectArray to
//    handle connections from TCP/IP sockets.
//
//**************************************************************************

#ifndef    _SOCKCONNECTARRAY_H
#define    _SOCKCONNECTARRAY_H

#include "ConnectArray.h"
#include "SockStream.h"

//**************************************************************************

class Cor_SockConnectArray : public Cor_ConnectArray {

  private:

      // A spot "likely" to be free in the connection array.
    int            nxt_conn;

    fd_set         select_msk;    // A mask to use for select

    Cor_sockbuf   *serv_buf;      // The server connection

  public:

      // Constructor
    Cor_SockConnectArray(unsigned short port = CORAL_PORT);
   ~Cor_SockConnectArray();
    
      // Make a new connection
    int NewConnection();

      // Delete a connection
    void DeleteConnection(int conn_indx);

      // Establish a connection for Explain
    int ExplainConnection();

      // Get the next connection with data and set it up to run
    int NextConn();
};

// *************************************************************************

#endif    _SOCKCONNECTARRAY_H
