// *************************************************************************
//    Assert.h
// *************************************************************************

#ifndef _Assert_H_
#define _Assert_H_

#include <stdlib.h>
#include <iostream.h>

// *************************************************************************

// __PRETTY_FUNCTION__ is a gcc/g++ thing

#ifdef DEBUG
#define ASSERT(x) do { if(!(x)) \
    { cerr << "** Assertion (" #x ") failed at line " << __LINE__ \
        << " of file \"" << __FILE__ << "\"\n(function: " \
        << __PRETTY_FUNCTION__ << ").\n"; \
     abort(); }} while(0) 

#else

#define ASSERT(x)    do {} while(0)

#endif

// *************************************************************************

#endif _Assert_H_
