// *************************************************************************
//    GenericIndexSet.C
// *************************************************************************

#include "Globals.h"
#include "GenericIndexSet.h"

#include "Unparse.h"
#include "Debug.h"

// *************************************************************************
int Cor_GenericIndexSet::add_all_indices( Cor_StorageRelation *reln)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (rel->arity() != reln->arity()) {
        *(Cor_exEnv->err_strm) << 
            "add_all_indices: relations of different arities.\n";
        return COR_I_FAIL;
    }

    for (int i=0; i < num_in_array; i++) {
        (Indices[i])->add_index_to_reln(reln);
    }
    return COR_I_SUCCESS;  
}

// *************************************************************************
Cor_GenericIndexSet::~Cor_GenericIndexSet() {

    // Magic doesn't work with this in.
    if (! Cor_exEnv->i_am_magic())
        delete [] Indices;
}

// *************************************************************************
void Cor_GenericIndexSet::print_adornments(ostream *outf)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    *outf << ": indexes ";
    for (int i = 0; i < num_in_array; i++) {
        // NOTE:: right now, only argument form indices are printed out
        if (Indices[i]->argset) {
            Cor_print_adornment(*(Indices[i]->argset), outf);
            *outf << " ";
        }
    }
}

// *************************************************************************

