// *************************************************************************
//    PredicateList.h
// *************************************************************************

#include <iostream.h>

#include "PredicateList.h"

#include "Debug.h"

Cor_PredicateList::Cor_PredicateList()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    size = 0;
    head = tail = curr = NULL;
}

Cor_PredicateList::~Cor_PredicateList()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
}

void Cor_PredicateList::append(Cor_Predicate *item)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (tail != NULL)  {
        tail->next = new list_node_t;
        tail->next->data = item;
        tail->next->next = NULL;
        tail = tail->next;
    } else {
        ASSERT(head == NULL);
        head = new list_node_t;
        head->data = item;
        head->next = NULL;
        tail = head;
    }

    size++;

    if (!curr)
        curr = head;
}

Cor_Predicate *Cor_PredicateList::get_next(void)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    if (!curr)
        return NULL;

    Cor_Predicate *predicate = curr->data;
    curr = curr->next;
    return predicate;
}

void Cor_PredicateList::reset(void)
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    curr = head;
}

void Cor_PredicateList::print()
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    cout << "printing the list with size = " << size << endl;
    for (list_node_t *node = head; node; node = node->next) 
        cout << node->data << endl;
}
