// *************************************************************************
//    Scc.h
// *************************************************************************

#ifndef _Scc_H_
#define _Scc_H_

#include "CoralStream.h"

// *************************************************************************

class Cor_Predicate;
class Cor_SccInfo;
class  Cor_Scc;

struct PredList {
  Cor_Predicate *pred;
  struct PredList *next;
};

// *************************************************************************
// Scc structure used for scc analysis of rules

class  Cor_Scc {

  public:

    Cor_Scc         *next;       // sccs are chained through this field
    Cor_Predicate   *preds;      // list of predicates in the scc
    int              scc_no;     // scc number
    struct PredList *ext_preds;  // list of external predicates
    Cor_SccInfo     *sccInfo;    // sccInfo associated with this scc
    int              recursive;
    int              emitted;    //Last ExportInfo::sequence that generatd code

    void print(ostream *fd, int print_preds = 1, int print_rules = 1);
};

// *************************************************************************

#endif _Scc_H_
