// *************************************************************************
//	ClauseInfo.h
// *************************************************************************

#ifndef _ClauseInfo_H_
#define _ClauseInfo_H_

#include "BitVector.h"
#include "Rule.h"

// *************************************************************************
//	ClauseInfo is used to pass information between various subroutines.
//	It is also used to hold "global" information when using scan_vars().

class Cor_Sips;

class ClauseInfo {

  public:
	Cor_Clause *rule;
	int *var_defining_pred;		// First body pred occurence where the variable
				 				// occurs, -1 if it doesn't occur in the body
	Cor_BitVector *var_head_arg_pos; // pos in the head where var appears
	int i;		 				//	Used to communicate with scan_vars().
	char *sip_generated;
	Cor_Sips *cur_sips;
	Cor_BitVector *adorn;
	Cor_BitVector *tail;

    ClauseInfo() {
        rule  = NULL;
        var_defining_pred = NULL;
        var_head_arg_pos  = NULL;
        i = 0;
        sip_generated = NULL;
        cur_sips      = NULL;
        adorn = NULL;
        tail  = NULL;
    };

};

// *************************************************************************

#endif _ClauseInfo_H_
